/* Copyright (C) 2013-2016 Vincent Forest (vaplv@free.fr)
 *
 * The RSys library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * The RSys library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with the RSys library. If not, see <http://www.gnu.org/licenses/>. */

#include "rsys.h"

int
main(int argc, char** argv)
{
  ATOMIC atom = 0;
  ATOMIC tmp;
  (void)argc, (void)argv;

  tmp = ATOMIC_INCR(&atom);
  CHECK(atom, 1);
  CHECK(tmp, 1);
  tmp = ATOMIC_ADD(&atom, 5);
  CHECK(atom, 6);
  CHECK(tmp, 6);
  tmp = ATOMIC_DECR(&atom);
  CHECK(atom, 5);
  CHECK(tmp, 5);
  tmp = ATOMIC_SUB(&atom, 7);
  CHECK(atom, -2);
  CHECK(tmp, -2);

  tmp = ATOMIC_CAS(&atom, 0, -1);
  CHECK(atom, -2);
  CHECK(tmp, -2);
  tmp = ATOMIC_CAS(&atom, 0, -2);
  CHECK(atom, 0);
  CHECK(tmp, -2);
  tmp = ATOMIC_SET(&atom, 9);
  CHECK(atom, 9);
  CHECK(tmp, 0);
  tmp = ATOMIC_GET(&atom);
  CHECK(tmp, 9);

  return 0;
}

